class ECAPA_TDNN(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : Optional[bool]
  blocks : __torch__.torch.nn.modules.container.___torch_mangle_9961.ModuleList
  mfa : __torch__.speakerlab.models.ecapa_tdnn.ECAPA_TDNN.___torch_mangle_9967.TDNNBlock
  asp : __torch__.speakerlab.models.ecapa_tdnn.ECAPA_TDNN.AttentiveStatisticsPooling
  asp_bn : __torch__.speakerlab.models.ecapa_tdnn.ECAPA_TDNN.___torch_mangle_9977.BatchNorm1d
  fc : __torch__.speakerlab.models.ecapa_tdnn.ECAPA_TDNN.___torch_mangle_9979.Conv1d
  def forward(self: __torch__.speakerlab.models.ecapa_tdnn.ECAPA_TDNN.ECAPA_TDNN,
    x: Tensor) -> Tensor:
    fc = self.fc
    asp_bn = self.asp_bn
    asp = self.asp
    mfa = self.mfa
    blocks = self.blocks
    _3 = getattr(blocks, "3")
    blocks0 = self.blocks
    _2 = getattr(blocks0, "2")
    blocks1 = self.blocks
    _1 = getattr(blocks1, "1")
    blocks2 = self.blocks
    _0 = getattr(blocks2, "0")
    x0 = torch.transpose(x, 1, 2)
    _4 = (_0).forward()
    _5 = (_1).forward((_0).forward1(x0, ), )
    _6 = (_2).forward(_5, )
    x1 = torch.cat([_5, _6, (_3).forward(_6, )], 1)
    _7 = (asp).forward((mfa).forward(x1, ), )
    _8 = (fc).forward((asp_bn).forward(_7, ), )
    x2 = torch.transpose(_8, 1, 2)
    return torch.squeeze(x2, 1)
class TDNNBlock(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : Optional[bool]
  conv : __torch__.speakerlab.models.ecapa_tdnn.ECAPA_TDNN.Conv1d
  activation : __torch__.torch.nn.modules.activation.___torch_mangle_9770.ReLU
  norm : __torch__.speakerlab.models.ecapa_tdnn.ECAPA_TDNN.BatchNorm1d
  def forward(self: __torch__.speakerlab.models.ecapa_tdnn.ECAPA_TDNN.TDNNBlock) -> NoneType:
    return None
  def forward1(self: __torch__.speakerlab.models.ecapa_tdnn.ECAPA_TDNN.TDNNBlock,
    x: Tensor) -> Tensor:
    norm = self.norm
    activation = self.activation
    conv = self.conv
    _5 = (activation).forward((conv).forward(x, ), )
    return (norm).forward(_5, )
class Conv1d(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : Optional[bool]
  conv : __torch__.torch.nn.modules.conv.___torch_mangle_9769.Conv1d
  def forward(self: __torch__.speakerlab.models.ecapa_tdnn.ECAPA_TDNN.Conv1d,
    x: Tensor) -> Tensor:
    conv = self.conv
    L_in = ops.prim.NumToTensor(torch.size(x, 2))
    _6 = torch.sub(torch.sub(L_in, CONSTANTS.c0), CONSTANTS.c1)
    _7 = torch.floor_divide(_6, CONSTANTS.c1)
    L_out = torch.add(_7, CONSTANTS.c1)
    _8 = torch.floor_divide(torch.sub(L_in, L_out), CONSTANTS.c2)
    _9 = int(_8)
    _10 = torch.floor_divide(torch.sub(L_in, L_out), CONSTANTS.c2)
    input = torch.pad(x, [_9, int(_10)], "reflect")
    return (conv).forward(input, )
class BatchNorm1d(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : Optional[bool]
  norm : __torch__.torch.nn.modules.batchnorm.___torch_mangle_9771.BatchNorm1d
  def forward(self: __torch__.speakerlab.models.ecapa_tdnn.ECAPA_TDNN.BatchNorm1d,
    argument_1: Tensor) -> Tensor:
    norm = self.norm
    return (norm).forward(argument_1, )
class SERes2NetBlock(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : Optional[bool]
  tdnn1 : __torch__.speakerlab.models.ecapa_tdnn.ECAPA_TDNN.___torch_mangle_9777.TDNNBlock
  res2net_block : __torch__.speakerlab.models.ecapa_tdnn.ECAPA_TDNN.Res2NetBlock
  tdnn2 : __torch__.speakerlab.models.ecapa_tdnn.ECAPA_TDNN.___torch_mangle_9826.TDNNBlock
  se_block : __torch__.speakerlab.models.ecapa_tdnn.ECAPA_TDNN.SEBlock
  def forward(self: __torch__.speakerlab.models.ecapa_tdnn.ECAPA_TDNN.SERes2NetBlock,
    argument_1: Tensor) -> Tensor:
    se_block = self.se_block
    tdnn2 = self.tdnn2
    res2net_block = self.res2net_block
    tdnn1 = self.tdnn1
    _11 = (res2net_block).forward((tdnn1).forward(argument_1, ), )
    _12 = (se_block).forward((tdnn2).forward(_11, ), )
    return torch.add(_12, argument_1)
class Res2NetBlock(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : Optional[bool]
  blocks : __torch__.torch.nn.modules.container.___torch_mangle_9820.ModuleList
  def forward(self: __torch__.speakerlab.models.ecapa_tdnn.ECAPA_TDNN.Res2NetBlock,
    argument_1: Tensor) -> Tensor:
    blocks = self.blocks
    _6 = getattr(blocks, "6")
    blocks3 = self.blocks
    _5 = getattr(blocks3, "5")
    blocks4 = self.blocks
    _4 = getattr(blocks4, "4")
    blocks5 = self.blocks
    _3 = getattr(blocks5, "3")
    blocks6 = self.blocks
    _2 = getattr(blocks6, "2")
    blocks7 = self.blocks
    _1 = getattr(blocks7, "1")
    blocks8 = self.blocks
    _0 = getattr(blocks8, "0")
    _13, x, x_i, x_i0, x_i1, x_i2, x_i3, x_i4, = torch.chunk(argument_1, 8, 1)
    _14 = (_0).forward(x, )
    x3 = torch.add(x_i, _14)
    _15 = (_1).forward(x3, )
    x4 = torch.add(x_i0, _15)
    _16 = (_2).forward(x4, )
    x5 = torch.add(x_i1, _16)
    _17 = (_3).forward(x5, )
    x6 = torch.add(x_i2, _17)
    _18 = (_4).forward(x6, )
    x7 = torch.add(x_i3, _18)
    _19 = (_5).forward(x7, )
    x8 = torch.add(x_i4, _19)
    _20 = [_13, _14, _15, _16, _17, _18, _19, (_6).forward(x8, )]
    return torch.cat(_20, 1)
class SEBlock(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : Optional[bool]
  conv1 : __torch__.speakerlab.models.ecapa_tdnn.ECAPA_TDNN.___torch_mangle_9828.Conv1d
  relu : __torch__.torch.nn.modules.activation.___torch_mangle_9829.ReLU
  conv2 : __torch__.speakerlab.models.ecapa_tdnn.ECAPA_TDNN.___torch_mangle_9831.Conv1d
  sigmoid : __torch__.torch.nn.modules.activation.___torch_mangle_9832.Sigmoid
  def forward(self: __torch__.speakerlab.models.ecapa_tdnn.ECAPA_TDNN.SEBlock,
    argument_1: Tensor) -> Tensor:
    sigmoid = self.sigmoid
    conv2 = self.conv2
    relu = self.relu
    conv1 = self.conv1
    x = torch.mean(argument_1, [2], True)
    _21 = (relu).forward((conv1).forward(x, ), )
    _22 = (sigmoid).forward((conv2).forward(_21, ), )
    return torch.mul(_22, argument_1)
class AttentiveStatisticsPooling(Module):
  __parameters__ = []
  __buffers__ = []
  training : bool
  _is_full_backward_hook : Optional[bool]
  tdnn : __torch__.speakerlab.models.ecapa_tdnn.ECAPA_TDNN.___torch_mangle_9973.TDNNBlock
  tanh : __torch__.torch.nn.modules.activation.Tanh
  conv : __torch__.speakerlab.models.ecapa_tdnn.ECAPA_TDNN.___torch_mangle_9975.Conv1d
  def forward(self: __torch__.speakerlab.models.ecapa_tdnn.ECAPA_TDNN.AttentiveStatisticsPooling,
    argument_1: Tensor) -> Tensor:
    conv = self.conv
    tanh = self.tanh
    tdnn = self.tdnn
    L = ops.prim.NumToTensor(torch.size(argument_1, 2))
    _23 = int(L)
    _24 = int(L)
    _25 = int(L)
    _26 = annotate(number, L)
    _27 = ops.prim.NumToTensor(torch.size(argument_1, 0))
    lengths = torch.ones([int(_27)], dtype=None, layout=None, device=torch.device("cpu"), pin_memory=False)
    length = torch.mul(lengths, L)
    _28 = torch.arange(_26, dtype=6, layout=None, device=torch.device("cpu"), pin_memory=False)
    mask = torch.lt(torch.expand(_28, [1, _25]), torch.unsqueeze(length, 1))
    mask0 = torch.to(mask, torch.device("cpu"), 6)
    mask1 = torch.unsqueeze(mask0, 1)
    total = torch.to(torch.sum(mask1, [2], True), 6)
    m = torch.div(mask1, total)
    mean = torch.sum(torch.mul(m, argument_1), [2])
    _29 = torch.sub(argument_1, torch.unsqueeze(mean, 2))
    _30 = torch.sum(torch.mul(m, torch.pow(_29, 2)), [2])
    _31 = torch.clamp(_30, 9.9999999999999998e-13)
    std = torch.sqrt(_31)
    mean0 = torch.repeat(torch.unsqueeze(mean, 2), [1, 1, _24])
    std0 = torch.repeat(torch.unsqueeze(std, 2), [1, 1, _23])
    x = torch.cat([argument_1, mean0, std0], 1)
    _32 = (tanh).forward((tdnn).forward(x, ), )
    input = torch.masked_fill((conv).forward(_32, ), torch.eq(mask1, 0), -inf)
    m0 = torch.softmax(input, 2)
    mean1 = torch.sum(torch.mul(m0, argument_1), [2])
    _33 = torch.sub(argument_1, torch.unsqueeze(mean1, 2))
    _34 = torch.sum(torch.mul(m0, torch.pow(_33, 2)), [2])
    _35 = torch.clamp(_34, 9.9999999999999998e-13)
    std1 = torch.sqrt(_35)
    pooled_stats = torch.cat([mean1, std1], 1)
    return torch.unsqueeze(pooled_stats, 2)
